{ diffnorm.p ʬβ }
{ (c) Kenrou Adachi, 1993/2007      }
{ for gpc-2.95.3, uses eggx         }
{ d^2x/dt^2 = fy(x, y, t)           }
{   <===>                           }
{     dx / dt = y, (= fx(x, y, t)   }
{     dy / dt = fy(x, y, t)         }



program diffnorm(input, output);

const
   BLUE	  = 4;
   YELLOW = 7;

{$I eggxhead.p}

{$I func2.p}

procedure input_data(var a, xo, yo, ts, te : real);
begin
   writeln;
   writeln('x Ͱ [-a, a] ꤷƲ');
   write('    a = '); readln(a);
   writeln('x  dx/dt ν xo  dxo ϤƲ');
   write('   xo = '); readln(xo);
   write('  dxo = '); readln(yo);
   writeln('֤Ѱ [ts, te] ꤷƲ');
   write('   ts = '); readln(ts);
   write('   te = '); readln(te)
end; { input_data }


procedure window(    a, ts, te : real; var dx, dt, ox, ot :real);
begin
   dx :=  2.0 * a;
   dt :=  te - ts;
   ox :=  400.0 * a / dx;
   ot := -640.0 * ts /dt
end; { window }


procedure axes;
begin
   gsetcolor(BLUE);
   gline(0.0, 0.0, 0.0, 399.0);
   gline(0.0, 199.0, 639.0, 199.0)
end; { axes }


procedure draw(xo, yo, ts, te, dx, dt, ox, ot : real);
var
   t, h	: real;
   i	: integer;

   procedure pre_draw_graph(xo, ts, dx, dt, ox, ot : real);
   var
      oldx, oldt : real;
   begin
      gsetcolor(YELLOW);
      oldx := 400.0 + 400.0 * xo / dx - ox;
      oldt :=  640.0 * ts / dt + ot;
      gmoveto(oldt, oldx)
   end; { pre_draw_graph }

   procedure runge_kutta(var xo, yo, t : real; h : real);
   var
      x1, x2, x3, x4, y1, y2, y3, y4 : real;
   begin
      x1 := h * fx(xo, yo, t);
      y1 := h * fy(xo, yo, t);
      x2 := h * fx(xo + x1 / 2.0, yo + y1 / 2.0, t + h / 2.0);
      y2 := h * fy(xo + x1 / 2.0, yo + y1 / 2.0, t + h / 2.0);
      x3 := h * fx(xo + x2 / 2.0, yo + y2 / 2.0, t + h / 2.0);
      y3 := h * fy(xo + x2 / 2.0, yo + y2 / 2.0, t + h / 2.0);
      x4 := h * fx(xo + x3, yo + y3, t + h);
      y4 := h * fy(xo + x3, yo + y3, t + h);

      xo := xo + (x1 + 2.0 * x2 + 2.0 * x3 + x4) / 6.0;
      yo := yo + (y1 + 2.0 * y2 + 2.0 * y3 + y4) / 6.0;
      t  := t + h
   end; { runge_kutta }

   procedure draw_graph(xo, dx, dt, ox, ot, t : real);
   begin
      glineto(640.0 * t / dt + ot, 400.0 + 400.0 * xo / dx - ox)
   end; { draw_graph }

begin {draw}
   h := (te - ts) / 640.0;
   t := ts;

   pre_draw_graph(xo, t, dx, dt, ox, ot);

   for i := 1 to 640 do
   begin
      runge_kutta(xo, yo, t, h);
      draw_graph(xo, dx, dt, ox, ot, t)
   end
end; { draw }


var
   a, xo, yo, ts, te : real;
   dx, dt, ox, ot    : real;
   dummy	     : char;
begin { main }
   repeat
      input_data(a, xo, yo, ts, te)
   until (a > 0.0) and (a <= 128.0) and (abs(xo) <= abs(a));

   ginit;
   axes;
   window(a, ts, te, dx, dt, ox, ot);
   draw(xo, yo, ts, te, dx, dt, ox, ot);

   writeln('λޤǤդΥ򲡤Ʋ');
   readln(dummy);
   gfinish
end. { main }

   